//+------------------------------------------------------------------+
//|                                                        Aroon.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

//
//
//
//
//

extern int    AroonPeriod     = 25;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 

//
//
//
//
//

double buffer1[];
double buffer2[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1); SetIndexLabel(0,"Aroon Up");
   SetIndexBuffer(1,buffer2); SetIndexLabel(1,"Aroon Down");
   SetIndexBuffer(2,trend);
   IndicatorShortName("Aroon ("+AroonPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      buffer1[i] = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
      buffer2[i] = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
      trend[i]   = trend[i+1];
         if(buffer1[i]>buffer2[i]) trend[i] = 1;
         if(buffer1[i]<buffer2[i]) trend[i] =-1;
   }
   
   //
   //
   //
   //
   //
     
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Aroon " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Aroon "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
   